/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is AddressbooksSynchronizer.
 *
 * The Initial Developer of the Original Code is Günter Gersdorf.
 * Portions created by the Initial Developer are Copyright (C) 2006
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *  Günter Gersdorf <G.Gersdorf@ggbs.de>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

var gDoc;
var gWindow;
var gSingleBook;

var gLifeTime;
var abURI=null;
var ioService=Components.classes["@mozilla.org/network/io-service;1"]
               .getService(Components.interfaces.nsIIOService);

var gMabs;
var gMabFile;
var gMabName;

var warn=0;

var strings;
var externalApp;
var externalAppHandler;

var cleanUp=null;
var gAbort=0;

var gForce;
var gCheckLastMod=true;

function downloadDone() {
  refreshAddressbook();
}
function remoteDownloadDone() {
  if (!gAddressbooksSync.noexternalappset) {
  //alert('app='+externalApp+' handler='+externalAppHandler);
    if (externalApp) {
      var syncprotocol = gAddressbooksSync.protocol;
      if (externalApp==-1)
        pref.clearUserPref("network.protocol-handler.external."+syncprotocol);
      else
        pref.setBoolPref("network.protocol-handler.external."+syncprotocol, true);
    }
    if (externalAppHandler)
      pref.setCharPref("network.protocol-handler.app."+syncprotocol, externalAppHandler);
    externalApp=null;
    externalAppHandler=null;
  }
  downloadDone();
}
function localDownloadDone() {
  downloadDone();
}

//TODO: welche Addressb�cher sind auf dem Server zu finden!?
function download(singleBook, force)
{
//dump('in download appstart='+gAddressbooksSync.appstarttime+' state='+gAddressbooksSync.state+'\n');
  gLifeTime=3;
  gForce=force||gAddressbooksSync.forceDownload;
    gAddressbooksSync.forceDownload=false;
  gCheckLastMod = gAddressbooksSync.checkLastModTime;
  var synctype=gAddressbooksSync.synctype;

  gUsesPopup=window.location=='chrome://addressbookssync/content/download.xul';
  if (gUsesPopup) {
//    window.moveTo(0,0);
      //v could be removed in next version!
        var dialogElement = document.documentElement;
        dialogElement.removeAttribute("persist");
        dialogElement.removeAttribute("height");
        dialogElement.removeAttribute("width");
        dialogElement.removeAttribute("screenX");
        dialogElement.removeAttribute("screenY");
      //^
  }
  strings = document.getElementById("ggbs_abs_strings");

  statustxt(synctype, -1, false, 'Start download ('+synctype+')');

  gAddressbooksSync.count=0;
  gSingleBook=singleBook;
  gMabs=gAddressbooksSync.syncedAddressbooks('down', singleBook);
  if (synctype=='local') {
    gTempName='abstemp.mab';
    cleanUp=localDownloadDone;
    if (gUsesPopup) setTimeout(getLocalData, 0);  // need time to show the popup
    else getLocalData();
  } else if (synctype=='remote') {
    gTempName='abstemp.mab';
    abURI=getSyncURI(false);
    if (!gAddressbooksSync.noexternalappset) {
      var syncprotocol = gAddressbooksSync.protocol;
//dump('setting externalApp preferences for '+syncprotocol+'\n');
      try { externalApp=pref.getBoolPref("network.protocol-handler.external."+syncprotocol); }
        catch(e) { externalApp=-1; }
      if (externalApp) pref.setBoolPref("network.protocol-handler.external."+syncprotocol, false);
      //ubuntu seems to ignore the value of external.xxx, therefore:
      try {
        externalAppHandler=pref.getCharPref("network.protocol-handler.app."+syncprotocol);
        if (externalAppHandler) pref.clearUserPref("network.protocol-handler.app."+syncprotocol);
      } catch(e) { externalAppHandler=''; }
    }
    cleanUp=remoteDownloadDone;
    if (gUsesPopup) setTimeout(getData, 0);
    else getData();
  } else if (synctype=='imap') {
    if (gUsesPopup) setTimeout(imapLoad, 0);
    else imapLoad();
  } else {
    killMe();
  }
}

function getLocalData() {
  var localpath=gAddressbooksSync.localpath;
  if (!localpath) { //preferences not set!
    killMe();
    return;
  }
  var path = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
  path.initWithPath( localpath );
  while (gMabs.Count()>0) {
    if (gAbort) break;
    dir=gMabs.GetElementAt(0);
    gMabs.RemoveElement(dir)
    var mabName;
    var mabFile;
    var externalFilename;
    var newSinglebook;
    if (dir instanceof Components.interfaces.nsIAbDirectory) {
      var dirProp = gAddressbooksSync.noDirProp?dir:dir.directoryProperties;
      mabName=dir.dirName;
      mabFile=dirProp.fileName;

      if ((gForce || !gCheckLastMod) && !askOverwrite(dir, false)) {
        statustxt('- '+mabName+" "+strings.getString('skipped'), 3, false);
        continue;
      }
      externalFilename=gAddressbooksSync.externalFilename(dir);
      newSinglebook=false;
    } else {  // new single book
      mabName = dir.QueryInterface(Components.interfaces.nsISupportsString).data;
      externalFilename = mabName+'.mab';
      mabFile = mabName.replace( /\W/g, "_" )+'.mab';
      newSinglebook=true;
//dump('getLocalData, new single book filename='+externalFilename+'\n');
    }
    statustxt('- '+mabName+'..', 1, false);

    var file = Components.classes["@mozilla.org/file/local;1"].
      createInstance(Components.interfaces.nsILocalFile);
    file.initWithFile( path );
    file.appendRelativePath( externalFilename );
    if (!file.exists()) {
      statustxt(strings.getString('nofile'), 2, true, null, file.path);
      continue;
    }

    var lms='';
    if (!newSinglebook) {
      var localMabFile = getDir('ProfD');
      localMabFile.appendRelativePath( mabFile );
      var lmfd=timeString(localMabFile.lastModifiedTime);
      var lfd=timeString(file.lastModifiedTime);
      lms='lastMod mab:'+lmfd+' file:'+lfd;

      if (!gForce && gCheckLastMod) {
        if (localMabFile.lastModifiedTime >= file.lastModifiedTime) {
          statustxt(strings.getString('skipped'), 2, false, null, lms);
          continue;
        } else if (!askOverwrite(dir, false)) {
          statustxt(strings.getString('skipped'), 2, false, null, 'Policy: '+gAddressbooksSync.downloadpolicy);
          continue;
        }
      }
    }

    var ret;
//    if (externalFilename.substr(-5)=='.ldif' || externalFilename.substr(-4)=='.ldi') {
    if (externalFilename.match(/\.ldif?$/i)) {
      var dir=gAddressbooksSync.getAddressBook(mabFile);  //dir=nsIAbDirectory
      if (!dir) return 'failed to find addressbook';
dump('---load ldif\n');
//  statustxt("+", 0, false, null); //
dump('clear addressbook\n');
//dumpDir(dir, 'At Start:');
      var ret=gAddressbooksSync.clearAddressBook(dir);
      if (ret)
        statustxt(strings.getString('notcopied'), 2, true, null, ret);
      else {
//  statustxt("+", 0, false, null); //
dump('read LDIF\n');
        var observerService=Components.classes["@mozilla.org/observer-service;1"]
          .getService(Components.interfaces.nsIObserverService);
        LDIFloaded.dir=dir;
        LDIFloaded.lms=lms;
        LDIFloaded.os=observerService;
        LDIFloaded.type='local';
        observerService.addObserver(LDIFloaded,"LDIFcomplete",false);
        gAddressbooksSync.LDIFAddressBook(dir, file);
        //loading LDIF is ASYNCHRONOUS!
        return;
      }
    } else {
      if ((ret=replaceAddressBook(mabName, mabFile, file))) {
        statustxt(strings.getString('notcopied'), 2, true, null, ret);
      } else {
        statustxt(strings.getString('copied'), 2, false, null, lms);
        gAddressbooksSync.count+=1;
        if (newSinglebook) abs_init(); // insert in options list
      }
    }
  }
  if (gSingleBook) alert(strings.getString('loaded'));
  killMe();

}
var LDIFloaded={
  dir: null,
  lms: null,
  os:  null,
  type: null,
  observe: function(subject, topic, status ) {
    if (topic=='LDIFcomplete') {
      var str=subject.QueryInterface( Components.interfaces.nsISupportsString);
dump(topic+': '+status+': '+str); //str ends with '\n'!
      this.os.removeObserver(LDIFloaded, 'LDIFcomplete' );
      if (status=='failed')
        statustxt(strings.getString('notcopied'), 2, true, null, str);
      else {
        this.dir.lastModifiedDate=gAddressbooksSync.appstarttime; //set to 'not modified'
        statustxt(strings.getString('copied'), 2, false, null, this.lms);
        gAddressbooksSync.count+=1;
      }
dump('calling next book\n');
      if (this.type=='local') getLocalData(); //continue with next book
      else if (this.type=='remote'){
        if (gUsesPopup) getData();  // next addressbook
        else setTimeout(getData, 1000);
      } else {
        if (gUsesPopup) setTimeout(imapLoadNextBook, 0);
        else imapLoadNextBook();
      }
    }
else dump('LDIFloaded: unknown topic '+topic+'\n');
  }
};

function getData()
{
  if (gAbort) {
    killMe();
    return;
  }
  if (!checkOffline('download')) return;


  if (!gMabs.Count()) {
    if (warn) gLifeTime=5;//a little bit longer
    if (gSingleBook) alert(strings.getString('loaded'));
    killMe();
    return;
  }

  var dir=gMabs.GetElementAt(0);
  gMabs.RemoveElement(dir);
  var externalFilename;
  var newSinglebook;
  if (dir instanceof Components.interfaces.nsIAbDirectory) {
    var dirProp = gAddressbooksSync.noDirProp?dir:dir.directoryProperties;
    gMabName=dir.dirName;
    gMabFile=dirProp.fileName;

    if ((gForce || !gCheckLastMod) && !askOverwrite(dir, false)) {
        statustxt('- '+gMabName+" "+strings.getString('skipped'), 3, false);
        getData();
        return;
    }

    externalFilename=gAddressbooksSync.externalFilename(dir);
    newSinglebook=false;
  } else {  // new single book
    gMabName = dir.QueryInterface(Components.interfaces.nsISupportsString).data;
    externalFilename=gMabName+'.mab';
    gMabFile = gMabName.replace( /\W/g, "_" )+'.mab';
    newSinglebook=true;
//dump('getData, new single book filename='+externalFilename+'\n');
  }
  if (!gMabName || gMabName=='false') {  //Merkw�rdiger Fehler (Lars Wohlfahrt, 16.6.08)
    statustxt('MabName='+gMabName+' dir='+dir+' single='+newSinglebook, 3, false);
    getData();  // next addressbook
  }
  statustxt('- '+gMabName+".", 1, false);  // 1. dot: start

  var mabURI=abURI+externalFilename;
  var URI=ioService.newURI(mabURI,null,null);

/*
  var protService=Components.classes["@mozilla.org/uriloader/external-protocol-service;1"]
               .getService(Components.interfaces.nsIExternalProtocolService);
  //Windows: from Registry HKCR\ftp\shell\open\command
  //Unix:    form preferences network.protocol-handler.app.
  if (protService.externalProtocolHandlerExists(URI.scheme)) {
    alert('external Protocol handler for '+URI.scheme+': '+
      protService.getApplicationDescription(URI.scheme));
  }
*/

  var flmt=null;
  if (!newSinglebook) {
    if (!gForce && gCheckLastMod) {
      //check for last modified date on download
      var localMabFile = getDir('ProfD');
      localMabFile.appendRelativePath( gMabFile );
      var flmt=new Date(localMabFile.lastModifiedTime);
    }
  //wenn keine ausgabe der lastmod time: forcierter download!!
  }
  var s=flmt?'lastMod mabfile:'+timeString(flmt):null;
  statustxt(".", 0, false, null, s); // 2. dot: start of download

  var error=gBookmarksSynchronizerDownloadService.start(
    URI, downloadCallback, gAddressbooksSync.usepost, flmt, dir);
  if(error)
    downloadCallback("done", error);
  else
    statustxt(".", 0, false); // 3. dot: download started
}

function downloadCallback(aStatus, aError, httpStatusText)
{
  if(aStatus != "done" && aError==0)
    return;

  switch(aError){
    case -2:
      return;
      break;
    case 0:
      //aError==0, if we have a file (not, if a error page was returned!)
      var s=gBookmarksSynchronizerDownloadService.remoteLastModTime?
        'lastMod remote: '+timeString(gBookmarksSynchronizerDownloadService.remoteLastModTime)
        :null;
      statustxt(".", 0, false, null, s); // 4. dot: download complete
      try{
        var abData=gBookmarksSynchronizerDownloadService.data;
        //mab data must start with: // <!-- <mdb:mork:z v="1.4"/> -->
        if (abData.substr( 0, 19 )=='// <!-- <mdb:mork:z') {
//reinsert probably missing second line (workaround a bug up to 0.8.2)
var i=abData.search(/[\r\n]</);
if (i>200) { //must reinsert!
abData=abData.replace(/([\r\n]+)/,'$1< <(a=c)> // (f=iso-8859-1)$1');
}
          var nsITmpFile = getDir('TmpD');
          nsITmpFile.appendRelativePath( gTempName );
          //file.createUnique(Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 0664);
          writeMabData(nsITmpFile, abData);
          statustxt(".", 0, false); // 5. dot: file written
          var err=replaceAddressBook(gMabName, gMabFile, nsITmpFile);
          if (err) {
            statustxt(err, 2, true);
            break;
          }
          statustxt(strings.getString('copied'), 2, false);
          gAddressbooksSync.count+=1;
          gWindow.abs_init(); // update options list, if necessary
        } else if (           //check for ldif file
              abData.indexOf('\ndn:')>=0 ||
              abData.indexOf('\nobjectclass:')>=0 ||
              abData.indexOf('\nsn:')>=0 ||
              abData.indexOf('\ncn:')>=0 ||
              abData.indexOf('\ngivenname:')>=0 ||
              abData.indexOf('\nmail:')>=0) {  //seems to be a ldif file
            var nsITmpFile = getDir('TmpD');
            nsITmpFile.appendRelativePath( gTempName );
            //file.createUnique(Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 0664);
            writeMabData(nsITmpFile, abData);
            statustxt(".", 0, false); // 5. dot: file written

            var dir=gAddressbooksSync.getAddressBook(gMabFile);  //dir=nsIAbDirectory
            if (!dir) {
              statustxt(strings.getString('notcopied'), 2, true, null, 'Dir not found');
              break;
            }
            var ret=gAddressbooksSync.clearAddressBook(dir);
            if (ret) {
              statustxt(strings.getString('notcopied'), 2, true, null, ret);
              break;
            }
            var observerService=Components.classes["@mozilla.org/observer-service;1"]
              .getService(Components.interfaces.nsIObserverService);
            LDIFloaded.dir=dir;
            LDIFloaded.lms='';
            LDIFloaded.os=observerService;
            LDIFloaded.type='remote';
            observerService.addObserver(LDIFloaded,"LDIFcomplete",false);
            gAddressbooksSync.LDIFAddressBook(dir, nsITmpFile);
            //loading LDIF is ASYNCHRONOUS!
            return; //do not break!
        } else { // some unknown fileformat
dump('---download failed, neither mab nor ldif, file start is '+abData.substr( 0, 200 )+'\n');
          statustxt('Unknown file format', 2, true);
          warn=1;
        }
      } catch(e) {
        if(e && e.toString().match(/^absync\:(.+)$/))
          statustxt(RegExp.$1, 2, true);
      }
      break;
    case 0x804b0002: // NS_BINDING_ABORTED: Download stopped because of timecheck
      var s=gBookmarksSynchronizerDownloadService.remoteLastModTime?
        'lastMod remote: '+timeString(gBookmarksSynchronizerDownloadService.remoteLastModTime)
        :'Policy: '+gAddressbooksSync.downloadpolicy;
      statustxt(strings.getString('skipped'), 2, false, null, s);
      break;
    default:
//dump(aError+': '+httpStatusText+'\n');
      if (httpStatusText)
        statustxt(errorstr(aError), 2, true, null, httpStatusText);
      else if (aError)
        statustxt(errorstr(aError), 2, true);
      else
        statustxt(strings.getString('failed'), 2, true);
      warn=1;
      break;
  }
  if (gUsesPopup) getData();  // next addressbook
  else setTimeout(getData, 1000);
}

function cancelDownload()
{
  if (gAbort) {
    gAddressbooksSync.state=''; //Up-/Download ready
    gAbort++;
    killMe();
  } else {
    gAbort++;
    document.getElementById("abs_cancel").label='kill';
  }
  //gBookmarksSynchronizerDownloadService.cancel(); //No, or we may left behind with corrupt mabs
}


