/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is AddressbooksSynchronizer.
 *
 * The Initial Developer of the Original Code is Günter Gersdorf.
 * Portions created by the Initial Developer are Copyright (C) 2006
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *  Günter Gersdorf <G.Gersdorf@ggbs.de>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */
var gAccountManager = Components.classes["@mozilla.org/messenger/account-manager;1"]
    .getService(Components.interfaces.nsIMsgAccountManager);
//gUseDraft==false only:
var gMessageService = Components.classes["@mozilla.org/messenger/messagecopyservice;1"]
    .getService(Components.interfaces.nsIMsgCopyService);

var gImapFolder;
var gAccount;
var gIdentity;
var gMessenger;
var gQPEncoder;

var gUseDraft=true;
var gFakeDraft=true; // with SendMsg, if true: fake the draft folder (else use real draft folder and move)
var gSavedDraftFolder;

// from mailnews\base\public\nsMsgMessageFlags.h messenger/mailWindowOverlay.js
//#define MSG_FLAG_READ     0x0001    /* has been read */
const abs_MSG_FLAG_READ              = 0x000001;
const abs_MSG_FLAG_IMAP_DELETED      = 0x200000;
//  already defined in mailWindowOverlay.js

function imapSaveDone() {
dump('upload cleanUp\n');
  if (gUseDraft && gFakeDraft && gSavedDraftFolder) {
    gIdentity.draftFolder=gSavedDraftFolder;
    gSavedDraftFolder=null;
  }
  if (gAddressbooksSync.count>0) {
    statustxt('+', 1, false,'compacting..');
    if (gUsesPopup && !gAddressbooksSync.exiting) setTimeout(compact, 1000);  // really needed :-( but not at exit!!
    else compact();
  } else {
    statustxt('+', 3, false, 'compacting..'+strings.getString('skipped'));
    uploadDone(); //TODO: what, if compacting delayed??
  }
}
function imapLoadDone() {
  downloadDone();
}
function compact() {
  try { // could throw exception in case, server not reacheable
    gImapFolder.compact(null, null);  // only needed on upload
  } catch(e) { }
//  statustxt(strings.getString('ok'), 2, false);
  statustxt('ok', 2, false);
dump('compacting done\n');
  uploadDone();
}



///////////////////////////////////////////////////////////////////////
//  Save mab files to imap folder

function imapSave(syncedBooks) {
  gUseDraft=gAddressbooksSync.imapusedraft;
  gImapFolder = GetMsgFolderFromUri(gAddressbooksSync.imapfolder, true); //nsIRDFResource, nsIMsgFolder
  if (!gImapFolder) {
    statustxt(errorstr(-3), 2, true);
    killMe();
    return;
  }

  var server=gImapFolder.server;
  gAccount=gAccountManager.FindAccountForServer(server);
  gIdentity=gAccount.defaultIdentity;

  if (gUseDraft) {
    if (gFakeDraft) {
      // createMessage saves to the 'Draft' Folder of the given identity
      // temporary switch the Drafts-Folder to the to be used folder
      gSavedDraftFolder=gIdentity.draftFolder;
      gIdentity.draftFolder=gAddressbooksSync.imapfolder;
    }
    gTempName='';
  } else {
    gQPEncoder = new QuotedPrintableEncoder();
    gTempName='absmail.eml';
  }
  cleanUp=imapSaveDone; // register cleanup function

  //be sure, headers are read or else, delete of old messages will not work
  // calls imapSaveStage2 when finished
  statustxt('+',1,false,strings.getString('loadimap')+'..');
  if (gUsesPopup) loadHeaders(imapSaveStage2);
  else imapSaveStage2();  // loadHeaders works asynchron: bad when TB finishes without a popupwindow
  return;
}

function imapSaveStage2() {
  statustxt(strings.getString('ok'),2,false);
  if (gAbort) { killMe(); return; }

  if (gUsesPopup) setTimeout(imapSaveNextBook, 0);
  else imapSaveNextBook();
  return;
}

function imapSaveNextBook() {
  if (!gMabs.Count() || gAbort) {
dump('upload finished\n');
    killMe(); // kill status popup
    return;
  }

  var dir=gMabs.GetElementAt(0).QueryInterface(Components.interfaces.nsIAbDirectory);
  gMabs.RemoveElement(dir);
  var dirProp = gAddressbooksSync.noDirProp?dir:dir.directoryProperties;
  var mabName=dir.dirName;
  var mabFile=dirProp.fileName;

  var lmd = getLastModified(dir);
  var lmds='lastMod='+timeString(lmd*1000);
  if (!gAddressbooksSync.forcedUploadOf(mabFile) &&
      !gForce && gCheckLastMod && gAddressbooksSync.appstarttime>=lmd) {
    statustxt('- '+mabName+' '+strings.getString('skipped'), 3, false, null, lmds);
dump('upload '+mabName+' skipped ('+lmds+')\n');
    imapSaveNextBook();
    return;
  }
dump('upload '+mabName+' ('+lmds+')\n');

  var externalFilename=gAddressbooksSync.externalFilename(dir);
  externalFilename=externalFilename.replace(/\.ldif?$/i,'.mab');

  statustxt('- '+mabName+'.', 1, false, null, lmds);  // 1. dot: started

//  get old messages for this addressbook
  var deleteMsgs=Components.classes["@mozilla.org/supports-array;1"]
    .createInstance(Components.interfaces.nsISupportsArray);
  var msgId=getMsgId(externalFilename);
  var msgs=gImapFolder.messages;            //since TB3b2
  if (!msgs) msgs=gImapFolder.getMessages(null); //up to TB3b1
  while (msgs.hasMoreElements()) {    //simpleEnumerator
    var msg=msgs.getNext();
    msg.QueryInterface(Components.interfaces.nsIMsgDBHdr);
    if (msg.messageId == msgId) {
      deleteMsgs.AppendElement(msg);
    }
  }

  if (gUseDraft) saveAsDraft(externalFilename, mabName, mabFile, deleteMsgs);
  else           saveViaFile(externalFilename, mabName, mabFile, deleteMsgs);
  gAddressbooksSync.forceUploadOf(mabFile, false);
  gAddressbooksSync.count+=1;

  return;
}

/////////////////////////////////////////////////////////////////////////
//  Load mab files from imap folder


function imapLoad() {
  if (!checkOffline('download')) return;
  gImapFolder = GetMsgFolderFromUri(gAddressbooksSync.imapfolder, true);
  if (!gImapFolder || gImapFolder.server.type!='imap') {
    statustxt(errorstr(-3), 2, true);
    killMe();
    return;
  }

  gTempName='abstemp.mab';
  cleanUp=imapLoadDone; // register cleanup function


  var server=gImapFolder.server;
  gAccount=gAccountManager.FindAccountForServer(server);
  gIdentity=gAccount.defaultIdentity;

  statustxt('+',1,false,strings.getString('loadimap')+'..');

  loadHeaders(imapLoadStage2);
  return;
}

function imapLoadStage2() {
  statustxt(strings.getString('ok'),2,false);
  if (gAbort) { killMe(); return; }

  gMessenger = Components.classes['@mozilla.org/messenger;1'].createInstance().
    QueryInterface(Components.interfaces.nsIMessenger);

  if (gUsesPopup) setTimeout(imapLoadNextBook, 0);
  else imapLoadNextBook();
  return;
}


function imapLoadNextBook() {
  if (gAbort) { killMe(); return; }

  if (!gMabs.Count()) {
    if (gSingleBook) alert(strings.getString('loaded'));
    killMe(); // kill status popup
    return;
  }
  var dir=gMabs.GetElementAt(0);
  gMabs.RemoveElement(dir)
  var externalFilename;
  var newSinglebook;
  if (dir instanceof Components.interfaces.nsIAbDirectory) {
    var dirProp = gAddressbooksSync.noDirProp?dir:dir.directoryProperties;
    var mabName=dir.dirName;
    var mabFile=dirProp.fileName;

    if ((gForce || !gCheckLastMod) && !askOverwrite(dir, false)) {
        statustxt('- '+mabName+" "+strings.getString('skipped'), 3, false);
        imapLoadNextBook();
        return;
    }

    externalFilename=gAddressbooksSync.externalFilename(dir);
    newSinglebook=false;
  } else {
    mabName = dir.QueryInterface(Components.interfaces.nsISupportsString).data;
    externalFilename = mabName+'.mab';
    mabFile = mabName.replace( /\W/g, "_" )+'.mab';
    newSinglebook=true;
dump('getImapData, new single book filename='+externalFilename+'\n');
  }
  statustxt('- '+mabName+'.', 1, false);  // 1. dot: start

  // find the correct message (looking for the messageId)
  var msgId = getMsgId(externalFilename);
  var msgs=gImapFolder.messages;            //since TB3b2
  if (!msgs) msgs=gImapFolder.getMessages(null); //up to TB3b1
  var theMsg=null;
  var theMsgKey=0;
  while (msgs.hasMoreElements()) {
    var msg=msgs.getNext();
    msg.QueryInterface(Components.interfaces.nsIMsgDBHdr);
    // msg.messageKey are the id's as used by the imapserver
    // find the last corresponding message (but there should only be one)
    if (msg.messageId == msgId && msg.messageKey>theMsgKey) {
      theMsg=msg;
      theMsgKey=msg.messageKey;
    }
  }
  if (!theMsg) {
    statustxt(strings.getString('nomessage'), 2, newSinglebook);
    if (gUsesPopup) setTimeout(imapLoadNextBook, 0);
    else imapLoadNextBook();
    return;
  }
  statustxt('.', 0, false); // 2. dot: message found

  var lms;
  if (!newSinglebook && !gForce && gCheckLastMod) {
    var datestr=theMsg.ccList;
    if (datestr.substr(0,1)=='"' || datestr.substr(0,1)=="'") datestr=datestr.substr(1,datestr.length-2)
    var mlmt=new Date(datestr);
    var localMabFile = getDir('ProfD');
    localMabFile.appendRelativePath( mabFile );
    var flmt=new Date(localMabFile.lastModifiedTime);
    lms='lastMod mab: '+timeString(flmt)+' imap: '+timeString(mlmt);
    if (mlmt<=flmt) {
      statustxt(strings.getString('skipped'), 2, false, null, lms);
dump('download '+mabName+' skipped:\n  file-time='+flmt+'\n  msg-time='+mlmt+'\n');
dump('   file-time='+flmt.valueOf()+'  msg-time='+mlmt.valueOf()+'\n');
      imapLoadNextBook();
      return;
    } else if (!askOverwrite(dir, false)) {
      statustxt(strings.getString('skipped'), 2, false, null, 'Policy: '+gAddressbooksSync.downloadpolicy);
      imapLoadNextBook();
      return;
    }
  }
  statustxt('', 0, false, null, lms); // only output time messages

  var msgURI=gImapFolder.getUriForMsg(theMsg);
  var ms=gMessenger.messageServiceFromURI(msgURI);

  var streamListener = {
    body: '',
    mabName: null,
    mabFile: null,
    onDataAvailable: function(request, context, inputStream, offset, count){
      try {
        var sis=Components.classes["@mozilla.org/scriptableinputstream;1"].
          createInstance(Components.interfaces.nsIScriptableInputStream);
        sis.init(inputStream);
        this.body+=sis.read(count);
      } catch(ex) { alert(ex+'\noffset='+offset+' count='+count); }
    },
    onStartRequest: function(request, context) {
      this.body='';
    },
    onStopRequest: function(aRequest, aContext, aStatusCode) {
      if (!aStatusCode) {
        statustxt('.', 0, false); // 3. dot: message read
        // extract mab data from message
        var boundary=this.body.match(/boundary="(.*?)"/g);
        if (!boundary) {
          statustxt(' (encrypted) ', 0, false);
        } else if (boundary[1]) { //signed
          boundary=boundary[1].match(/boundary="(.*?)"/);
          boundary='--'+boundary[1];
        } else {                  //not signed
          boundary=boundary[0].match(/boundary="(.*?)"/);
          boundary='--'+boundary[1];
        }
        if (boundary) try {
          var ind=this.body.indexOf(boundary);     // start of text part
          if (ind<0) throw('noattachment');
          ind=this.body.indexOf(boundary, ind+1);  // start of mab part
          if (ind<0) throw('noattachment');
          var cte;
          var ci=this.body.indexOf('Content-Transfer-Encoding:', ind+1);
          if (ci>=0) {
            var cie=this.body.indexOf('\r', ci);
            if (cie<0) cie=this.body.indexOf('\n', ci);
            cte=this.body.substring(ci+27, cie);
          } else {
            cte='7bit';
          }
          var msgstart=this.body.indexOf('\n\n', ind+1);
          var sub;
          if (msgstart<0) {
            msgstart=this.body.indexOf('\r\n\r\n', ind+1);
            sub=2;
          } else
            sub=1;
          if (msgstart<0) throw('incompleteattachment');
          var msgend=this.body.indexOf(boundary, msgstart+2*sub);
          if (msgend<0) throw('incompleteattachment');
          var msg=this.body.substring(msgstart+2*sub,msgend-sub);
          if (cte=='base64')
            try {
              msg=msg.replace(/[\r\n]/gm,'');
              msg=atob(msg);
            } catch(e) { alert('base64: '+e); throw('incompleteattachment'); }
/*oldtest
          if (msg.substr(0,7)=='// <!--' ||      // mab file
              msg.substr(0,7)=='dn: cn=') {      // ldif file
*/
	          // write file to temporary file
	          var nsITmpFile=getDir('TmpD');
	          nsITmpFile.appendRelativePath(gTempName);
dump('abs: imap: write tempfile: '+nsITmpFile.path+'\n');
            if (writeMabData(nsITmpFile, msg)) {
  	          statustxt('.', 0, false); // 4. dot: temp file created
              if (msg.substr(0,7)=='// <!--') {
            	  try {
      	          // replace addressbook data
      	          var ret;
      	          if ((ret=replaceAddressBook(this.mabName, this.mabFile, nsITmpFile)))
      	            statustxt(ret, 2, true);
      	          else {
      	            statustxt(strings.getString('copied'), 2, false);
//###                    if (newSinglebook) abs_init(); // insert in options list
      	            gAddressbooksSync.count+=1;
      	          }
            	  } catch (e) {alert('imap replaceaddressbook: '+e); }
              } else {  // LDIF
                var dir=gAddressbooksSync.getAddressBook(this.mabFile);  //dir=nsIAbDirectory
                if (!dir)
                  statustxt(strings.getString('notcopied'), 2, true, null, 'Dir not found');
                else {
                  var ret=gAddressbooksSync.clearAddressBook(dir);
                  if (ret)
                    statustxt(strings.getString('notcopied'), 2, true, null, ret);
                  else {
                    var observerService=Components.classes["@mozilla.org/observer-service;1"]
                      .getService(Components.interfaces.nsIObserverService);
                    LDIFloaded.dir=dir;
                    LDIFloaded.lms='';
                    LDIFloaded.os=observerService;
                    LDIFloaded.type='imap';
                    observerService.addObserver(LDIFloaded,"LDIFcomplete",false);
                    gAddressbooksSync.LDIFAddressBook(dir, nsITmpFile);
                    //loading LDIF is ASYNCHRONOUS!
                    return; //do not break!
                  }
                }
              }
            } else {
              statustxt(strings.getString('notcopied')+' (?)', 2, true); //Bad Status
            }
/*oldtest
          } else {  //partly copied
            if (cte=='7bit')
              statustxt('attachment not a mab file', 2, true);
            else
              statustxt('unknown encoding '+cte, 2, true);
          }
*/
        } catch(e) {statustxt(e, 2, true);}
        else
          statustxt(strings.getString('noattachment'), 2, true);
      } else
        statustxt(strings.getString('notcopied')+' ('+aStatusCode+')', 2, true); //Bad Status
      if (gUsesPopup) setTimeout(imapLoadNextBook, 0);
      else imapLoadNextBook();
    } //OnStopRequest
  };  //streamListener

  streamListener.mabName=mabName;
  streamListener.mabFile=mabFile;
	var aurl = new Object();
	ms.CopyMessage(msgURI, streamListener, false, null, null, aurl);

  return;
}

/////////////////////////////////////////////////////////////////////////

// from messageWindow@48
// wait till all headers are read for the imap folder
function loadHeaders(callback) {
  var syncListener = {
    callback: null,
    mailSession : null,
    OnItemAdded: function(parentItem, item) {},
    OnItemRemoved: function(parentItem, item) {},
    OnItemPropertyChanged: function(item, property, oldValue, newValue) {},
    OnItemIntPropertyChanged: function(item, property, oldValue, newValue) {},
    OnItemBoolPropertyChanged: function(item, property, oldValue, newValue) {},
    OnItemUnicharPropertyChanged: function(item, property, oldValue, newValue){},
    OnItemPropertyFlagChanged: function(item, property, oldFlag, newFlag) {},
    OnItemEvent: function(folder, event) {
       var eventType = event.toString();

      if (eventType == "FolderLoaded") {
        if (folder) {
          var uri = folder.URI;
          if (uri == gAddressbooksSync.imapfolder) {
            this.mailSession.RemoveFolderListener(this);
            var msgFolder = folder.QueryInterface(Components.interfaces.nsIMsgFolder);
            if (msgFolder) {
              msgFolder.endFolderLoading();
              this.callback();
            }
          }
        }
      }
    }
  }
  // first be sure all header are available
  // when they are, the syncListener calls the next stage
  syncListener.callback=callback;
  var nsIFolderListener = Components.interfaces.nsIFolderListener;
  var mailSession = Components.classes["@mozilla.org/messenger/services/session;1"].
    getService(Components.interfaces.nsIMsgMailSession);
  syncListener.mailSession=mailSession;
  mailSession.AddFolderListener(syncListener, nsIFolderListener.event);
  gImapFolder.startFolderLoading();
  gImapFolder.updateFolder(null);
  return;
}

///////////////////////////////////////////////////////////////////////
function saveAsDraft(externalFilename, mabName, mabFile, deleteMsgs) {
  var stateListener = {
    mabName : null,
    msgCompose : null,
    QueryInterface: function(iid) {
//dump('query interface\n');
      if (iid.equals(Components.interfaces.nsIMsgComposeStateListener) ||
          iid.equals(Components.interfaces.nsISupports))
        return this;
      throw Components.results.NS_NOINTERFACE;
      return 0;
    },
    NotifyComposeFieldsReady: function() {  //not called
//dump('state listener: compose fields ready\n');
    },
    ComposeProcessDone: function(aResult) {
//dump('state listener: compose process done '+aResult+'\n');
      if (aResult) {
        this.msgCompose.UnregisterStateListener(this);
        statustxt(strings.getString('notcopied'), 2, true);
        if (gUsesPopup) setTimeout(imapSaveNextBook, 0);
        else imapSaveNextBook();
      }
    },
    SaveInFolderDone: function(folderURI) {
      statustxt(".", 0, false); // 4. dot: upload ready
      this.msgCompose.UnregisterStateListener(this);
      statustxt(strings.getString('copied'), 2, false);
      if (deleteMsgs.Count()>0) {
        try {
          gImapFolder.deleteMessages ( deleteMsgs, null, true, false, null, false);
        } catch(e) { //SeaMonkey
          var dm=Components.classes["@mozilla.org/array;1"].
              createInstance(Components.interfaces.nsIMutableArray);
          for (var i=0; i<deleteMsgs.Count(); i++)
            dm.appendElement(deleteMsgs.GetElementAt(i), false);
          gImapFolder.deleteMessages ( dm, null, true, false, null, false);
        }
      }
      if (gUsesPopup) setTimeout(imapSaveNextBook, 0);
      else imapSaveNextBook();
    }
  };

  var params = Components.classes["@mozilla.org/messengercompose/composeparams;1"]
    .createInstance(Components.interfaces.nsIMsgComposeParams);
  params.composeFields = Components.classes["@mozilla.org/messengercompose/composefields;1"]
    .createInstance(Components.interfaces.nsIMsgCompFields);
  params.composeFields.securityInfo = Components.classes["@mozilla.org/messenger-smime/composefields;1"]
    .createInstance(Components.interfaces.nsIMsgSMIMECompFields);

  //var encryptionPolicy = gIdentity.getIntAttribute("encryptionpolicy");
  // 0 == never, 1 == if possible, 2 == always Encrypt.
  params.composeFields.securityInfo.requireEncryptMessage=false;
  params.composeFields.securityInfo.signMessage=false; //=gIdentity.getBoolAttribute("sign_mail");

  params.identity = gIdentity;
  //Set to PlainText or the info part ("Do not delete") is missing
  params.format = Components.interfaces.nsIMsgCompFormat.PlainText;
    //.PlainText or .HTML, .Draft, , .Template, .Default
  params.type=Components.interfaces.nsIMsgCompType.New;
    //.New (=default) or .NewsPost,.MailToUrl, .Template, .Reply u.a.

  var composeFields = params.composeFields;
  composeFields.QueryInterface( Components.interfaces.nsIMsgCompFields);
  composeFields.subject = 'Addressbooks Synchronizer: '+externalFilename;
  composeFields.to = '"Addressbooks Synchronizer"'; //gIdentity.email; //needed, if doing encryption
//  composeFields.from = 'Addressbooks Synchronizer'; // does not work (automatically overridden) :-(
  composeFields.fcc = gAddressbooksSync.imapfolder; // else a 'FCC: imap://ggbs@mailhost.iwf.ing.tu-bs.de/INBOX/sent' appears
  composeFields.body = 'Addressbooks Synchronizer: '+externalFilename+'\nDo not delete this message!!!\n';

  composeFields.messageId = getMsgId(externalFilename);

  var attachment = Components.classes["@mozilla.org/messengercompose/attachment;1"].
    createInstance(Components.interfaces.nsIMsgAttachment);
  var addrbook=gAddressbooksSync.getAddressBook(mabFile);
  var directoryService =  Components.classes['@mozilla.org/file/directory_service;1'].
    getService(Components.interfaces.nsIProperties);
  var profileFolder = directoryService.get('ProfD',  Components.interfaces.nsIFile);
  var profileDir = profileFolder.QueryInterface(Components.interfaces.nsILocalFile);
  var nsIMabFile = profileDir.clone().QueryInterface(Components.interfaces.nsILocalFile);
  var dirProp = gAddressbooksSync.noDirProp?addrbook:addrbook.directoryProperties;
  nsIMabFile.appendRelativePath( dirProp.fileName );
  attachment.url = 'file://'+nsIMabFile.path;
  attachment.name = externalFilename;
  composeFields.addAttachment(attachment);
  var lmt=new Date(nsIMabFile.lastModifiedTime);
  composeFields.cc = lmt;
  composeFields.otherRandomHeaders = "X-LastModifiedTime: "+lmt+'\r\n';
//TODO: the timestamp inside the mabfile is incorrect, since not updated here!

  composeFields.bodyIsAsciiOnly = true;
  composeFields.forcePlainText  = true;
  composeFields.attachVCard   = false;

  var sMsgComposeService = Components.classes["@mozilla.org/messengercompose;1"]
      .getService(Components.interfaces.nsIMsgComposeService);
  if (sMsgComposeService)
  {
    var domWindow=window.QueryInterface(Components.interfaces.nsIDOMWindowInternal);
    var msgCompose = sMsgComposeService.InitCompose(domWindow, params);
    if (msgCompose)
    {
      statustxt(".", 0, false); // 2. dot: InitCompose done
      stateListener.mabName = mabName;
      stateListener.msgCompose = msgCompose;
      msgCompose.RegisterStateListener(stateListener);
        // .Save, .SaveAs und .Now does not work (Upload window verschwindet,
        //   aber immer noch up/download in Progress und kein Fehler in JavaScriptConsole
        // Mit .Now ist die message tats�chlich verschickt worden :-)
        // Mit .Later landet es in LocalFolders.unsent und will sp�ter versendet werden.
      msgCompose.SendMsg(Components.interfaces.nsIMsgCompDeliverMode.SaveAsDraft,
        gIdentity, gAccount.key, null, null);
      statustxt(".", 0, false); // 3. dot: SendMsg done
    }
  }
  return;
}

///////////////////////////////////////////////////////////////////////////
function saveViaFile(externalFilename, mabName, mabFile, deleteMsgs) {
  var qpName=gQPEncoder.Encode(externalFilename);  // quoted-printable encode the filename
  var time=Date.now();

  var nsIMabFile=getDir('ProfD');
  nsIMabFile.appendRelativePath( mabFile );
  abData=readMabData(nsIMabFile, false);
  if (!abData) {
    statustxt(strings.getString('notcopied'), 2, true);
    imapSaveNextBook();
    return;
  }
  statustxt(".", 0, false); // 2. dot: mab data loaded

  var header='';
  header+='Message-ID: '+getMsgId(externalFilename)+'\r\n';
  header+='Date: '+Date(time)+'\r\n';
  header+='From: '+gIdentity.email+'\r\n';
  header+='To: "Addressbooks Synchronizer"\r\n';
  header+='Subject: Addressbooks Synchronizer: =?ISO-8859-1?Q?'+qpName+'?=\r\n';
  var lmt=new Date(nsIMabFile.lastModifiedTime);
  header+='CC: '+lmt+'\r\n';
  header+='X-LastModifiedTime: '+lmt+'\r\n';
  header+='Content-Type: multipart/mixed; boundary="------------'+time+'"\r\n';
  header+='\r\n';
  header+='This is a multi-part message in MIME format.\r\n';
  header+='--------------'+time+'\r\n';
  header+='Content-Type: text/plain; charset=ISO-8859-1\r\n';
  header+='Content-Transfer-Encoding: quoted-printable\r\n';
  header+='\r\n';
  header+='Addressbooks Synchronizer: '+qpName+'\r\n';
  header+='Do not delete this message!!!\r\n';
  header+='\r\n';
  header+='--------------'+time+'\r\n';
  header+='Content-Type: text/plain; name="'+qpName+'"\r\n';
  header+='Content-Transfer-Encoding: 7bit\r\n';
  header+='Content-Disposition: inline; filename="'+qpName+'"\r\n';
  header+='\r\n';

  var tailer='';
  tailer+='\r\n';
  tailer+='--------------'+time+'\r\n';

  var nsITmpFile=getDir('TmpD');
  nsITmpFile.appendRelativePath(gTempName);
  if (!writeMabData(nsITmpFile, header+abData+tailer)) {
    statustxt(strings.getString('notcopied'), 2, true);
    imapSaveNextBook();
    return;
  }
  statustxt(".", 0, false); // 3. dot: tmp file written

  var deleteMsgsCount=deleteMsgs.Count();
  try {
    var fileSpec = Components.classes["@mozilla.org/filespec;1"].createInstance();
    fileSpec = fileSpec.QueryInterface( Components.interfaces.nsIFileSpec);
    fileSpec.nativePath = nsITmpFile.path;
    var isSeaMonkey=false;
  } catch(e) {
    var fileSpec = nsITmpFile;
    var isSeaMonkey=true;
    var dm=Components.classes["@mozilla.org/array;1"].
        createInstance(Components.interfaces.nsIMutableArray);
    for (var i=0; i<deleteMsgsCount; i++)
      dm.appendElement(deleteMsgs.GetElementAt(i), false);
    deleteMsgs=dm;
  }

  // listen for the end of a 'store to imap folder'
  var copyServiceListener = {
      uploaded: false,
      QueryInterface: function(iid) {
        if (iid.equals(Components.interfaces.nsIMsgCopyServiceListener) ||
            iid.equals(Components.interfaces.nsISupports))
          return this;
        throw Components.results.NS_NOINTERFACE;
        return 0;
      },

      OnProgress:  function(progress, progressMax) {
//dump('ABS: IMAP: OnProgress called: '+progress+' '+progressMax+'\n');
        // never called!!
      },

      OnStartCopy: function() {
//dump('ABS: IMAP: OnStartCopy called\n');
      },

      OnStopCopy:  function(status) {
//dump('ABS: IMAP: OnStopCopy called: status='+status+'\n');
        //Beim upload at onUnload ohne popupfenster
        //  existiert hier statustxt() und auch z.B. alert() nicht mehr
try { statustxt; } catch(e) { window.close; return; } //thunderbird h�ngt!
       if (!status) {          // store is finished
          statustxt(strings.getString('copied'), 2, false);
        } else {
          statustxt(errorstr(status), 2, true);
        }
       //deleteMsgs is nsISupportsArray, SeaMonkey needs nsIArray
       if (deleteMsgsCount>0)
          gImapFolder.deleteMessages ( deleteMsgs, null, true, false, null, false);
        if (gUsesPopup) setTimeout(imapSaveNextBook, 100);
        else imapSaveNextBook();
      },

      SetMessageKey:  function(key) {
//dump('ABS: IMAP: SetMessageKey called: key='+key+'\n');
        this.uploaded=true;
        statustxt(".", 0, false); // 4. dot: uploaded to server done
        // will not be called, if message not copied to server
        // will probably not called if server delivers no message key!?
      }
  }
  copyServiceListener.uploaded=false;
  // with gImapFolder.copyFileMessage, onStartCopy and onStopCopy gets not called!!
  if (!isSeaMonkey)
    gMessageService.CopyFileMessage(fileSpec, gImapFolder, null, false, abs_MSG_FLAG_READ,
      copyServiceListener, null);
  else
    gMessageService.CopyFileMessage(fileSpec, gImapFolder, null, false, abs_MSG_FLAG_READ, 'dummy',
      copyServiceListener, null);

  // next mabfile is started, when listener is informed about the end of the operation
  return;
}

/////////////////////////////////////////////////////////////////////////

function getMsgId(theName) {
  return encodeURI(theName+'@AddressBooksSynchronizer');
}

/*
 * from http://www.snippetcenter.org/de/conversion-to-content-transfer-encoding-quoted-printable-s1786.aspx
 */
function QuotedPrintableEncoder() {
  this.MaxLineSize = 76;
  this.Encode = QuotedPrintableEncode;
  this.EncodeLine = QuotedPrintableEncodeLine;
  this.EncodeCharacter = QuotedPrintableEncodeCharacter;
  // Exclamation point through less than, and greater than through tilde
  // Tab is not listed here as UnAltered but could be
  this.UnAltered = String.fromCharCode(32) + String.fromCharCode(60) + String.fromCharCode(62) + String.fromCharCode(126);
  this.UnAlteredEnd = String.fromCharCode(33) + String.fromCharCode(60) + String.fromCharCode(62) + String.fromCharCode(126);
}
function QuotedPrintableEncode(InputText) {
  var re = new RegExp("\r\n","g");
  var SplitText, i, s="";
  SplitText = InputText.split(re);
  for (i=0; i<SplitText.length; ++i) {
    s += this.EncodeLine(SplitText[i]);
    if (i<SplitText.length-1) s+="\r\n";
  }
  return s;
}
function QuotedPrintableEncodeLine(Text) {
  var SplitText, i, s="", c=256;
  if (Text.length == 0) return "";
  for (i=0; i<Text.length-1; ++i)
    s += this.EncodeCharacter(Text.charCodeAt(i), this.UnAltered);
  // Encode last character; if space, encode it
  s += this.EncodeCharacter(Text.charCodeAt(Text.length-1), this.UnAlteredEnd);
  if (s.length <= this.MaxLineSize) return s; // Split into lines of MaxLineSize characters or less
  SplitText = s.slice(0, this.MaxLineSize);
  i = this.MaxLineSize;
  while (i<s.length) {
    SplitText += "=\r\n"+ s.slice(i, i+this.MaxLineSize);
    i += this.MaxLineSize;
  }
  return SplitText;
}
function QuotedPrintableEncodeCharacter(Character, UnAltered) {
  var i, x, Alter=true;
  for (i=0; i<UnAltered.length; i+=2)
    if (Character >= UnAltered.charCodeAt(i) && Character <= UnAltered.charCodeAt(i+1))
      Alter=false;
  if (!Alter) return String.fromCharCode(Character);
  x = Character.toString(16).toUpperCase();
  return (x.length == 1) ? "=0" + x : "=" + x;
}
